#include "my_eml_func.h"
#include "rtw_capi.h"
#include "my_eml_func_private.h"

static rtwCAPI_Signals rtBlockSignals[] = {

  {
    0, 0, NULL, NULL, 0, 0, 0, 0, 0
  }
};

static rtwCAPI_LoggingBusElement rtBusElements[] = {
  { 0, rtwCAPI_signal }
};

static rtwCAPI_LoggingBusSignals rtBusSignals[] = {

  { NULL, NULL, 0, 0, NULL }
};

static rtwCAPI_States rtBlockStates[] = {

  {
    0, -1, NULL, NULL, NULL, 0, 0, 0, 0, 0, 0
  }
};

static rtwCAPI_DataTypeMap rtDataTypeMap[] = {

  {
    "", "", 0, 0, 0, 0, 0, 0
  }
};

static rtwCAPI_ElementMap rtElementMap[] = {

  { NULL, 0, 0, 0, 0 },
};

static rtwCAPI_DimensionMap rtDimensionMap[] = {

  {
    rtwCAPI_SCALAR, 0, 0, 0
  }
};

static uint_T rtDimensionArray[] = { 0 };

static rtwCAPI_FixPtMap rtFixPtMap[] = {

  { NULL, NULL, rtwCAPI_FIX_RESERVED, 0, 0, 0 },
};

static rtwCAPI_SampleTimeMap rtSampleTimeMap[] = {

  {
    NULL, NULL, 0, 0
  }
};

static int_T rtContextSystems[3];
static rtwCAPI_LoggingMetaInfo loggingMetaInfo[] = {
  { 0, 0, "", 0 }
};

static rtwCAPI_ModelMapLoggingStaticInfo mmiStaticInfoLogging = {
  3, rtContextSystems, loggingMetaInfo, 0, rtBusSignals
};

static rtwCAPI_ModelMappingStaticInfo mmiStatic = {

  { rtBlockSignals, 0 },

  { NULL, 0,
    NULL, 0 },

  { rtBlockStates, 0 },

  { rtDataTypeMap, rtDimensionMap, rtFixPtMap,
    rtElementMap, rtSampleTimeMap, rtDimensionArray },
  "float", &mmiStaticInfoLogging
};

static void my_eml_func_InitializeSystemRan(sysRanDType *systemRan[],
  int_T systemTid[], void *rootSysRanPtr, int rootTid)
{
  systemRan[0] = (sysRanDType *) rootSysRanPtr;
  systemRan[1] = NULL;
  systemRan[2] = NULL;
  systemTid[1] = rootTid;
  systemTid[2] = rootTid;
  systemTid[0] = rootTid;
  rtContextSystems[0] = 0;
  rtContextSystems[1] = 0;
  rtContextSystems[2] = 0;
}

void my_eml_func_InitializeDataMapInfo(RT_MODEL_my_eml_func *my_eml_func_M
  , void *sysRanPtr, int contextTid)
{
  rtwCAPI_SetVersion(my_eml_func_M->DataMapInfo.mmi, 1);
  rtwCAPI_SetStaticMap(my_eml_func_M->DataMapInfo.mmi, &mmiStatic);
  rtwCAPI_SetLoggingStaticMap(my_eml_func_M->DataMapInfo.mmi,
    &mmiStaticInfoLogging);
  rtwCAPI_SetPath(my_eml_func_M->DataMapInfo.mmi, NULL);
  rtwCAPI_SetFullPath(my_eml_func_M->DataMapInfo.mmi, NULL);
  rtwCAPI_SetInstanceLoggingInfo(my_eml_func_M->DataMapInfo.mmi,
    &my_eml_func_M->DataMapInfo.mmiLogInstanceInfo);
  rtwCAPI_SetChildMMIArray(my_eml_func_M->DataMapInfo.mmi, NULL);
  rtwCAPI_SetChildMMIArrayLen(my_eml_func_M->DataMapInfo.mmi, 0);
  my_eml_func_InitializeSystemRan(my_eml_func_M->DataMapInfo.systemRan,
    my_eml_func_M->DataMapInfo.systemTid, sysRanPtr, contextTid);
  rtwCAPI_SetSystemRan(my_eml_func_M->DataMapInfo.mmi,
                       my_eml_func_M->DataMapInfo.systemRan);
  rtwCAPI_SetSystemTid(my_eml_func_M->DataMapInfo.mmi,
                       my_eml_func_M->DataMapInfo.systemTid);
  rtwCAPI_SetGlobalTIDMap(my_eml_func_M->DataMapInfo.mmi,
    &my_eml_func_M->Timing.mdlref_GlobalTID[0]);
}
