#ifndef RTW_HEADER_my_eml_func_h_
#define RTW_HEADER_my_eml_func_h_
#include "rtw_modelmap.h"
#ifndef my_eml_func_COMMON_INCLUDES_
# define my_eml_func_COMMON_INCLUDES_
#include <stdlib.h>
#include <math.h>
#include <stddef.h>
#include <string.h>
#include "rtwtypes.h"
#include "simstruc.h"
#include "fixedpoint.h"
#include "rt_nonfinite.h"
#include "mwmathutil.h"
#endif

#include "my_eml_func_types.h"

struct RT_MODEL_my_eml_func {
  struct SimStruct_tag *_mdlRefSfcnS;
  struct {
    rtwCAPI_ModelMappingInfo mmi;
    rtwCAPI_ModelMapLoggingInstanceInfo mmiLogInstanceInfo;
    sysRanDType* systemRan[3];
    int_T systemTid[3];
  } DataMapInfo;

  struct {
    int_T mdlref_GlobalTID[1];
  } Timing;
};

typedef struct {
  RT_MODEL_my_eml_func rtm;
} rtMdlrefDWork_mr_my_eml_func;

extern void mr_my_eml_func_initialize(SimStruct * _mdlRefSfcnS, int_T
  mdlref_TID0, RT_MODEL_my_eml_func *my_eml_func_M, void *sysRanPtr, int
  contextTid, rtwCAPI_ModelMappingInfo *rt_ParentMMI, const char_T *rt_ChildPath,
  int_T rt_ChildMMIIdx, int_T rt_CSTATEIdx);
extern void mr_my_eml_func_MdlInfoRegFcn(SimStruct* mdlRefSfcnS, char_T
  *modelName);
extern void mr_my_eml_func(const real_T *rtu_0, const real_T *rtu_1, const
  real_T *rtu_2, const real_T *rtu_3, real_T *rty_0);

#endif
